import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MerchantType, MerchantTypeParam } from './model';
import { SERVER_API_URL } from '@/config/setting';

/**
 * 分页查询商户类型
 */
export async function pageMerchantType(params: MerchantTypeParam) {
  const res = await request.get<ApiResult<PageResult<MerchantType>>>(
    SERVER_API_URL + '/system/merchant-type/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商户类型列表
 */
export async function listMerchantType(params?: MerchantTypeParam) {
  const res = await request.get<ApiResult<MerchantType[]>>(
    SERVER_API_URL + '/system/merchant-type',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商户类型
 */
export async function addMerchantType(data: MerchantType) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-type',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商户类型
 */
export async function updateMerchantType(data: MerchantType) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-type',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商户类型
 */
export async function removeMerchantType(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-type/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商户类型
 */
export async function removeBatchMerchantType(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-type/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商户类型
 */
export async function getMerchantType(id: number) {
  const res = await request.get<ApiResult<MerchantType>>(
    SERVER_API_URL + '/system/merchant-type/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
